/* util.c ....... error message utilities.
 *                C. Scott Ananian <cananian@alumni.princeton.edu>
 *                hacked by mulix <mulix@actcom.co.il> 
 * $Id: util.c,v 1.2 2002/02/18 21:11:01 mulix Exp $
 */

#include <stdio.h>
#include <stdarg.h>
#include <syslog.h>
#include <unistd.h>
#include <stdlib.h>
#include "util.h"


void open_log(const char* prog_name) {
	openlog(prog_name ? prog_name : "(unknown)", LOG_PERROR | LOG_PID, LOG_DAEMON);
}

void close_log(void) {
	closelog();
}

#define MAKE_STRING(label) 				\
va_list ap;						\
char buf[256], string[256];				\
va_start(ap, format);					\
vsnprintf(buf, sizeof(buf), format, ap);		\
snprintf(string, sizeof(string), "%s[%s:%s:%d]: %s",	\
	 label, func, file, line, buf);			\
va_end(ap)

void _log(char *func, char *file, int line, char *format, ...) {
	MAKE_STRING("log");
	syslog(LOG_NOTICE, "%s", string);
}

void _warn(char *func, char *file, int line, char *format, ...) {
	MAKE_STRING("warn");
	syslog(LOG_WARNING, "%s\n", string);
	fprintf(stderr, "%s\n", string);
}

void _fatal(char *func, char *file, int line, char *format, ...) {
	MAKE_STRING("fatal");
	syslog(LOG_ERR, "%s\n", string);
	fprintf(stderr, "%s\n", string);
	close_log();
	exit(1);
}
