/* util.h ....... error message utilities.
 *                C. Scott Ananian <cananian@alumni.princeton.edu>
 *                hacked by mulix <mulix@actcom.co.il> 
 * $Id: util.h,v 1.2 2002/02/18 21:11:01 mulix Exp $
 */

/* util.h logging functions. */

#ifndef INC_UTIL_H
#define INC_UTIL_H

void open_log(const char* prog_name);
void close_log(void);


void _log(char *func, char *file, int line, char *format, ...)
__attribute__ ((format (printf, 4, 5)));
void _warn(char *func, char *file, int line, char *format, ...)
__attribute__ ((format (printf, 4, 5)));
void _fatal(char *func, char *file, int line, char *format, ...)
__attribute__ ((format (printf, 4, 5))) __attribute__ ((noreturn));

#define log(format, args...) \
	_log(__FUNCTION__,__FILE__,__LINE__, format , ## args)
#define warn(format, args...) \
	_warn(__FUNCTION__,__FILE__,__LINE__, format , ## args)
#define fatal(format, args...) \
	_fatal(__FUNCTION__,__FILE__,__LINE__, format , ## args)

#endif /* INC_UTIL_H */
